#!/usr/bin/python 
import os, sys, argparse
import numpy as np
util = os.path.join(os.environ["TUTORIALS"],
    "Tutorial_4/utilities")
sys.path.insert(0, util)
import geom

# parse command-line arguments
p = argparse.ArgumentParser()
p.add_argument("nproc", type=int)
p.add_argument("--dry", action="store_true")
args = p.parse_args()


# create a run directory RUN.<n>
i_run = 1
rundir = "RUN.{}".format(i_run)
os.chdir(rundir)

# loop over distances, 0 is for a single molecule
for dist in [0, 3.2, 3.4, 3.6, 3.8, 4, 4.4, 4.8, 5.6]:
    subdir = "{}".format(dist)
    print(subdir)
    os.chdir(subdir)
    if not args.dry:
        os.system("{0}/mbd/pymbd.py {0}/ts_script.py 2>ts.out".format(util))
    os.chdir("..")




