#!/usr/bin/python
import os, sys, re
import itertools
import subprocess

basis = sys.argv[1].lower()
bases_dir = os.environ["SPECIES"]
species = set()
with open('geometry.in') as f:
    for l in f:
        l = re.split(r"\s+", l.strip())
        if l[0] in ["atom", "atom_frac", "empty"]:
            species.add(l[4].lower())
avail_bases = subprocess.Popen("find {} -name 01_H_default".format(bases_dir), stdout=subprocess.PIPE, shell=True).communicate()[0]
avail_bases = avail_bases.strip().split("\n")
for bas in avail_bases:
    if "/{}/".format(basis) in bas.lower():
        basis_dir = os.path.dirname(bas)
        break
specie_files = os.listdir(basis_dir)
used_species = []
for specie in species:
    for sp_file in specie_files:
        if "_{}_".format(specie) in sp_file.lower():
            used_species.append(sp_file)
            break
for sp_file in used_species:
    with open(os.path.join(basis_dir, sp_file)) as f:
        print(f.read())

