#!/usr/bin/env python
# -*- coding: utf-8 -*-
#  
#  Use:
#  plot_MD.py column_number file1 file2 ..  file
#
import numpy as np
import matplotlib.pyplot as plt
from sys import argv

if len(argv) < 2:
    print("Use: plot_MD.py column# file1 file2 ... file")

"""
Here You can change the y-axis energy window:
"""
################
e_window = 100.0
################

column=int(argv[1])-1
file_list = []
for f in range(2,len(argv)):
     file_list.append(argv[f])
     
data = {}
for f in file_list:
    data[f] = np.genfromtxt(f, skip_header=1)


ylabel=["Time [ps]","Temperature (nuclei)","elec. Free Energy [eV]","Nuclear kinetic energy","Total Energy(t) - Total Energy(t=0)\n[meV]","Conserved Hamiltonian(t) -\n Conversed Hamiltonian(t=0) [meV]"]
nout = len(file_list)
col = ['b', 'g', 'r', 'y', 'c', 'k']
#label_ex1_D = [ r'$D_{5}O_{2}^{+}$ ' + str(x) + r' fs' for x in [0.5, 1.0, 2.0, 2.5, 3.0 ]]
#label_ex1_H = [ r'$H_{5}O_{2}^{+}$ ' + str(x) + r' fs' for x in [0.5, 1.0, 2.0, 2.5, 3.0 ]]
#label_ex2   = [ r'NH', r'BDP', r'GLE']

#Here You can midify y-offset and energy window:
Et0 = data[file_list[0]][0,column]

xmax_l = [] 
fig, ax = plt.subplots( figsize=(8,4))
for f, n in zip(file_list, list(range(nout))):
    ax.plot(data[f][:,0], (data[f][:,column]-Et0)*1000, col[n], label=f) #label_ex2[n])
    xmax_l.append(data[f][-1,0])

xmax = max(xmax_l)
ax.set_xlim(0,xmax)
ax.set_ylim(-e_window, e_window)
ax.set_yticks(np.linspace(-e_window,+e_window,11))
ax.set_xticks(np.linspace(0,xmax,7))
#ax.ticklabel_format(useOffset=False)
ax.set_xlabel(r'time [ps]')
ax.set_ylabel(ylabel[column])
ax.legend(ncol=1, loc=4)

fig.tight_layout()
fig.savefig('MD_run.png', dpi=200)
