#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  process_MD.py
#  Written by Wang Weiqi and MM for 2015 HandsOn
#  Strongly based on former perl scripts.
#  USE: python process_MD.py filename
#  Generates output filename.MD.out with set of energies
#  NVE - microcanonical ensemble
#  NPT - canonical ensemble (Nose-Hooves, BDP and GLE thermostats)


from pylab import *
from sys import argv
filename=argv[1]
output_file = file(filename+'.MD.dat', 'w' )
output_type = str(raw_input("Please enter ensemble (NVE/NVT): "))
if output_type == 'NVE' or output_type == 'NVT':
    pass
else:   
    print "An ensemble not supported!",
    exit


#---------------------------------aims_MD_eval---------------------------
def print_MD_status():
	file.next()
	line = file.next()
	TS = float(line.split()[-2])
	line = file.next()
	FE = float(line.split()[-2])
	line = file.next()
	T = float(line.split()[-2])
	line = file.next()
	KE = float(line.split()[-2])
	line = file.next()
	TE = float(line.split()[-2])
	global i,TE_zero
	if i == 0 :
		TE_zero = TE
		i = 1
	line = file.next()
        if output_type == 'NVT':
#	if line.split()[2]=='value' or line.split()[1]=='BDP':
		if line.split()[2]=='value':	# Nose-Hoover; skip two lines
			s = line.split()[5]
			line = file.next()
			ps = line.split()[5]
			line = file.next()
		if line.split()[1]=='Nose-Hoover' or line.split()[1]=='BDP':
			H_NH = float(line.split()[4])
			TE_change = TE - TE_zero
			print >> output_file, "%18.8f %16.6f %25.6f %25.6f %25.6f %25.6f %25.6f\n" %(TS,T,FE,KE,TE,H_NH,TE_change),
		else:
			TE_change = TE - TE_zero
			print >> output_file, "%18.8f %16.6f %25.6f %25.6f %25.6f %25.6f\n" %(TS,T,FE,KE,TE,TE_change),
	else:
		TE_change = TE - TE_zero
		print >> output_file, "%16.6f %16.6f %25.6f %25.6f %25.6f %25.6f\n" %(TS,T,FE,KE,TE,TE_change),

#----------------------------------aims_MD_eval-------------------------------------------
def aims_MD_eval():
	for line in file:
		if '#' not in line:
			if 'Initial conditions for Born-Oppenheimer Molecular Dynamics:' in line:
				print_MD_status()
			if 'Advancing structure using Born-Oppenheimer Molecular Dynamics' in line:
				file.next()
				print_MD_status()
	file.close()

#----------------------------------aims_NH_BDP--------------------------------------------
def aims_NH_BDP():
	for line in file:
		if '#' not in line:
			if '| Simulation time           :' in line:
				TS = float(line.split()[-2])
			elif '| Electronic free energy    :' in line:
				FE = float(line.split()[-2])
			elif '| Temperature (nuclei)      :' in line:
				T = float(line.split()[-2])
			elif '| Nuclear kinetic energy    :' in line:
				KE = float(line.split()[-2])
			elif '| Total energy (el.+nuc.)   :' in line:
				TE = float(line.split()[-2])
			elif '| BDP pseudo-Hamiltonian    :' in line:
				NHH = float(line.split()[-2])
				print >> output_file, "%15.6f %15.6f %23.6f %23.6f %23.6f %23.6f\n" %(TS,T,FE,KE,TE,NHH),
			elif '| Nose-Hoover Hamiltonian   :' in line:
				NHH = float(line.split()[-2])
				print >> output_file, "%15.6f %15.6f %23.6f %23.6f %23.6f %23.6f\n" %(TS,T,FE,KE,TE,NHH),
                        elif '| GLE pseudo hamiltonian    :' in line:
                                NHH = float(line.split()[-2])
                                print >> output_file, "%15.6f %15.6f %23.6f %23.6f %23.6f %23.6f\n" %(TS,T,FE,KE,TE,NHH),

#------------------------------------aims_NH_BDP------------------------------------------

if output_type == 'NVE':
	#------------------------------print the title of each column-----------------------
	str_TS = 'Time [ps]'
	str_T	= 'Temperature [K]'
	str_FE   = 'E_tot (electronic) [eV]'
	str_KE   = 'E_kin (nuclei) [eV]'
	str_TE   = 'Total Energy [eV]'
	str_TE_change   = 'Total Energy Change [eV]'
	print >> output_file, "#%15s %16s %25s %25s %25s %25s\n" %(str_TS,str_T,str_FE,str_KE,str_TE,str_TE_change),
	#-----------------------------------------------------------------------------------
	file = open(filename)
	TS=0.0					#time of steps
	T=0.0					#temperture
	FE=0.0					#free energy
	KE=0.0					#kinetic energy
	TE=0.0					#total energy
	TE_change=0.0			#total energy change
	TE_zero=0.0				#initial total energy
	H_NH=0.0
	i=0
	aims_MD_eval()
elif output_type == 'NVT':
	#------------------------------print the title of each column-----------------------
	str_TS = '#      Time [ps]'
	str_T    = 'Temperature (nuclei)'
	str_FE   = 'elec. Free Energy [eV]'
	str_KE   = 'Nuclear kinetic energy'
	str_TE   = 'Total Energy [eV]'
	str_NHH  = 'Conserved Hamilt. [eV]'
	print >> output_file, "%15s %15s %23s %23s %23s %23s\n" %(str_TS,str_T,str_FE,str_KE,str_TE,str_NHH),
	#-----------------------------------------------------------------------------------
	file = open(filename)
	TS=0.0			#time of steps
	T=0.0			#temperture
	FE=0.0			#free energy
	KE=0.0			#kinetic energy
	TE=0.0			#total energy
	NHH=0.0			#conserved hamiltonian
	aims_NH_BDP()

output_file.close()
