#!/bin/bash

util=$TUTORIALS/Tutorial_4/utilities
nproc=1
exe=$util/aims.x
while getopts b:n:e: opt; do
    case $opt in
        n) nproc=$OPTARG
            ;;
        b) basis=$OPTARG
            ;;
        e) exe=$OPTARG
    esac
done
shift $(( OPTIND-1 ))
if [ -z $basis ]; then
    echo "Error: basis set has to be specified with -b" >&2
    exit 1
fi
set -e

irun=1
rundir=RUN.$irun
while [ -e $rundir ]; do
    irun=$(( irun+1 ))
    rundir=RUN.$irun
done
mkdir $rundir
cp control.in geometry.in $rundir
cd $rundir
`dirname $0`/add_species.py $basis >> control.in
mpirun -n $nproc $exe | tee aims.out
